
#include <cstring>

struct DATE
{
	unsigned short giorno;
	unsigned short mese;
	unsigned short anno;
};


class Prodotto
{
 private:

	 unsigned long long codice;
	 char descrizione[128];
	 DATE scadenza;
	 unsigned short calorie;

 public:

	 Prodotto(void)
	 {
		 codice = 0;
		 strcpy(descrizione, "");
		 scadenza = { 0, 0, 0 };
		 calorie = 0;
	 }

	 Prodotto(unsigned long long codice, char descrizione[], DATE scadenza, unsigned int calorie)
	 {
		 this->codice = codice;
		 strcpy(this->descrizione, descrizione);
		 this->scadenza = scadenza;
		 this->calorie = calorie;
	 }

	 unsigned long long getCodice(void)
	 {
		 return codice;
	 }

	 void getDescrizione(char descrizione[])
	 {
		 strcpy(descrizione, this->descrizione);
	 }

	 DATE getScadenza(void)
	 {
		 return scadenza;
	 }

	 unsigned short getCalorie(void)
	 {
		 return calorie;
	 }

	 bool scaduto(DATE data)
	 {
		 if (data.anno > scadenza.anno)
			 return true;
		 if (data.anno < scadenza.anno)
			 return false;
		 // data.anno == scadenza.anno
		 if (data.mese > scadenza.mese)
			 return true;
		 if (data.mese < scadenza.mese)
			 return false;
		 // data.mese == scadenza.mese
		 if (data.giorno > scadenza.giorno)
			 return true;
		 return false;
	 }
};

