
#include "Time.h"

class EnglishTime : public Time {

public:

	using Time::setHour;

	EnglishTime(void) : Time() {}

	EnglishTime(int h, int m, int s) : Time(h, m, s) {}

	EnglishTime(int h, int m, int s, bool pm)
	{
		if (pm)
		{
			if (h >= 1 && h<12) hour = h + 12;
			else
			{
				if (h == 12) hour = 12;
				else hour = 0;
			}
		}
		else
		{ // AM
			if (h >= 1 && h<12) hour = h;
			else hour = 0;
		}
		if (m >= 0 && m <= 59) minute = m;
		else minute = 0;
		if (s >= 0 && s <= 59) second = s;
		else second = 0;
	}

	void setHour(int h, bool pm)
	{
		if (pm)
		{
			if (h >= 1 && h<12) hour = h + 12;
			if (h == 12) hour = 12;
		}
		else
		{ // AM
			if (h >= 1 && h<12) hour = h;
			if (h == 12) hour = 0;
		}
	}

	int getEnglishHour(void)
	{
		if (hour>12) return hour - 12;
		else
		{
			if (hour == 0)
				return 12;
			else return hour;
		}
	}

	bool isPM(void)
	{
		if (hour >= 12) return true;
		else return false;
	}
};