

#include <iostream>

using namespace std;


#include "Point.h";


class Polyline
{
 private:

 int n;
 int size;
 Point* list;

 public:
 
 Polyline(int s)
 {
  n = 0; size = s;
  list = new Point[size];
 }

 ~Polyline(void)
 {
  delete[] list;
 }

 int getN(void) {return n;}

 void addEndPoint(Point p)
 {
  if (n < size)
  {
	  list[n] = p; n++;
  };
 }

void delEndPoint(void)
{
 if (n > 0) {n--;}
}

Point getPoint(int i)
{
 Point O = Point(0,0);

 if (i>=0 && i<n)
   return list[i];
 else
     return O; // (0,0) = ERRORE
}

void setPoint (int i, Point p)
{
 if (i>=0 && i<n)
   list[i] = p;
}

double getLength(void)
{
 int i; double len = 0;
 Point P, Q;

 for (i=0; i<n-1; i++)
    {
     P = list[i]; Q = list[i+1];
     len = len + P.distance(Q);
    }
 return len;
}
};

double len(Polyline p)
{
	return p.getLength();
}


void main(void)
{
 Point A(1,0), B(1,1), C(2,1), D(2,2), P(0,1);
 Polyline poly(5); // dimensione massima polilinea: 5 punti
 
 //Polyline pippo = poly;
 //double d = len(poly);

 poly.addEndPoint(A); // aggiunta punto A
 cout << "punti = " << poly.getN() << " lunghezza = " << poly.getLength() << endl;
 poly.addEndPoint(B); // aggiunta punto B
 cout << "punti = " << poly.getN() << " lunghezza = " << poly.getLength() << endl;
 poly.addEndPoint(C); // aggiunta punto C
 cout << "punti = " << poly.getN() << " lunghezza = " << poly.getLength() << endl;
 poly.addEndPoint(D); // aggiunta punto D
 cout << "punti = " << poly.getN() << " lunghezza = " << poly.getLength() << endl;
 poly.setPoint(3,P); // sostituzione punto D con punto P
 cout << "punti = " << poly.getN() << " lunghezza = " << poly.getLength() << endl;
 // visualizzazione di tutti i punti della polilinea
 for (int i=0; i<poly.getN(); i++)
    cout << "(" << poly.getPoint(i).getX() <<", " << poly.getPoint(i).getY() << ") ";
 cout << endl;
 poly.delEndPoint(); // eliminazione ultimo punto
 cout << "punti = " << poly.getN() << " lunghezza = " << poly.getLength() << endl;
}
