
#include "Prodotto.h"


struct RECORD
{
	unsigned long long codice;
	char descrizione[128];
	DATE scadenza;
	unsigned short calorie;
};


class Frigorifero
{
 private:

	 Prodotto *prodotti;
	 unsigned int numero_prodotti;
	 unsigned int numero_massimo_prodotti;

 public:

	 Frigorifero(unsigned short numero_massimo_prodotti);

	 ~Frigorifero(void);

	 void salvaProdotti(void);

	 void caricaProdotti(void);

	 bool inserisciProdotto(Prodotto prodotto);

	 bool estraiProdotto(unsigned long long codice, DATE scadenza, Prodotto* prodotto);

	 unsigned int elencoProdotti(Prodotto elenco[]);

	 unsigned int elencoProdottiScaduti(DATE data, Prodotto elenco[]);

	 unsigned int quantitaProdotto(unsigned long long codice);
};

