
#include "Frigorifero.h"
#include <iostream>


int main(void)
{
	Prodotto prodotti[10];
	Prodotto p;
	int n;

	DATE d1 = { 15, 2, 2017 };
	Prodotto p1(1234567890, "prodotto1", d1, 1000);
	DATE d2 = { 25, 12, 2017 };
	Prodotto p2(9876543210, "prodotto2", d2, 99);

	Frigorifero frigorifero(10);

	std::cout << "Numero prodotti: " << frigorifero.elencoProdotti(prodotti) << std::endl;
	frigorifero.inserisciProdotto(p1);
	std::cout << "Numero prodotti: " << frigorifero.elencoProdotti(prodotti) << std::endl;
	frigorifero.inserisciProdotto(p1);
	std::cout << "Numero prodotti: " << frigorifero.elencoProdotti(prodotti) << std::endl;
	frigorifero.inserisciProdotto(p2);
	std::cout << "Numero prodotti: " << frigorifero.elencoProdotti(prodotti) << std::endl;
	std::cout << "Quantit prodotto: " << frigorifero.quantitaProdotto(1234567890) << std::endl;
	std::cout << "Quantit prodotto: " << frigorifero.quantitaProdotto(123456789) << std::endl;
	std::cout << "Quantit prodotto: " << frigorifero.quantitaProdotto(9876543210) << std::endl;
	n = frigorifero.elencoProdotti(prodotti);
	std::cout << "Elenco prodotti:" << std::endl;
	for (int i = 0; i < n; i++)
	{
		char descrizione[128];
		prodotti[i].getDescrizione(descrizione);
		std::cout << descrizione << std::endl;
	}
	frigorifero.salvaProdotti();
	if (frigorifero.estraiProdotto(1234567890, d1, &p))
	{
		char descrizione[128];
		p.getDescrizione(descrizione);
		std::cout << "Prodotto estratto: " << descrizione << std::endl;
	}
	n = frigorifero.elencoProdotti(prodotti);
	std::cout << "Elenco prodotti:" << std::endl;
	for (int i = 0; i < n; i++)
	{
		char descrizione[128];
		prodotti[i].getDescrizione(descrizione);
		std::cout << descrizione << std::endl;
	}
	if (frigorifero.estraiProdotto(9876543210, d2, &p))
	{
		char descrizione[128];
		p.getDescrizione(descrizione);
		std::cout << "Prodotto estratto: " << descrizione << std::endl;
	}
	n = frigorifero.elencoProdotti(prodotti);
	std::cout << "Elenco prodotti:" << std::endl;
	for (int i = 0; i < n; i++)
	{
		char descrizione[128];
		prodotti[i].getDescrizione(descrizione);
		std::cout << descrizione << std::endl;
	}
	frigorifero.caricaProdotti();
	n = frigorifero.elencoProdotti(prodotti);
	std::cout << "Elenco prodotti:" << std::endl;
	for (int i = 0; i < n; i++)
	{
		char descrizione[128];
		prodotti[i].getDescrizione(descrizione);
		std::cout << descrizione << std::endl;
	}
	n = frigorifero.elencoProdottiScaduti(d2, prodotti);
	std::cout << "Elenco prodotti scaduti:" << std::endl;
	for (int i = 0; i < n; i++)
	{
		char descrizione[128];
		prodotti[i].getDescrizione(descrizione);
		std::cout << descrizione << std::endl;
	}
}
